/*
  LED bar graph

Ce skecht qui simule le fonctionnement de 2 Volets Roulants allume des leds de manire continue au fur et  mesure du temps qui passe (18s de manoeuvre du VR au total)

Il est bas sur une carte Arduino Pro mini 128, chaque Vloet est Compos de 8 LED (Voir schma Annexe)

2 entres par volet roulant permettent de commander le sens d'incrmentation ou de dcrmentation des LEDS

 created juin 2016
 
 par David BOURBOUJAS
 
 A partir du sketch d'exemple BARGRAPH

 */


// these constants won't change:
// set pin numbers:
const int buttonPinUP_G = 8;     // the number of the pushbutton pin
const int buttonPinDOWN_G = 9;     // the number of the pushbutton pin
const int ledCount_G = 6;    // the number of LEDs in the bar graph
int VRState_G; // hauteur du VR

const int buttonPinUP_D = 11;     // the number of the pushbutton pin
const int buttonPinDOWN_D = 10;     // the number of the pushbutton pin
const int ledCount_D = 6;    // the number of LEDs in the bar graph
int VRState_D; // hauteur du VR

// variables will change:
int buttonStateUP_G = 0;         // variable for reading the pushbutton status
int buttonStateDOWN_G = 0;         // variable for reading the pushbutton status

int ledPins_G[] = {
  2, 3, 4, 5, 6, 7 
};   // an array of pin numbers to which LEDs are attached

int buttonStateUP_D = 0;         // variable for reading the pushbutton status
int buttonStateDOWN_D = 0;         // variable for reading the pushbutton status

int ledPins_D[] = {
  A3, A2, A1, A0, 13, 12
};   // an array of pin numbers to which LEDs are attached


void setup() {
  // loop over the pin array and set them all to output:
  for (int thisLed_G = 0; thisLed_G < ledCount_G; thisLed_G++) {
    pinMode(ledPins_G[thisLed_G], OUTPUT);
  }
  // initialize the pushbutton pin as an input:
  pinMode(buttonPinUP_G, INPUT);
  pinMode(buttonPinDOWN_G, INPUT);

  VRState_G = 0;

  for (int thisLed_D = 0; thisLed_D < ledCount_D; thisLed_D++) {
    pinMode(ledPins_D[thisLed_D], OUTPUT);
  }
  // initialize the pushbutton pin as an input:
  pinMode(buttonPinUP_D, INPUT);
  pinMode(buttonPinDOWN_D, INPUT);

  VRState_D = 0;

  Serial.begin(9600);
}

void loop() {
  // read the state of the pushbuttons value:
  buttonStateUP_G = digitalRead(buttonPinUP_G);
  buttonStateDOWN_G = digitalRead(buttonPinDOWN_G);
  buttonStateUP_D = digitalRead(buttonPinUP_D);
  buttonStateDOWN_D = digitalRead(buttonPinDOWN_D);
  
  // check if the pushbutton is pressed.
  // if it is, the buttonUPState is HIGH:
  if (buttonStateUP_G == HIGH) {
    if (VRState_G < ledCount_G) {
 VRState_G++;
  Serial.println("VR G UP");
    }
    else VRState_G = ledCount_G;
  }

  // if it is, the buttonDOWNState is HIGH:
  if (buttonStateDOWN_G == HIGH) {
    if (VRState_G >0 ) {
  VRState_G--;
  Serial.println("VR G DOWN");
  }
    else { VRState_G = 0;}
    }

  Serial.print("Position VR G:");
  Serial.println(VRState_G);
  // map the result to a range from 0 to the number of LEDs:
  int ledLevel_G = map(VRState_G, 0, ledCount_G, 0, ledCount_G);

  // loop over the LED array:
  for (int thisLed_G = 0; thisLed_G < ledCount_G; thisLed_G++) {
    // if the array element's index is less than ledLevel,
    // turn the pin for this element on:
    if (thisLed_G < ledLevel_G) {
      digitalWrite(ledPins_G[thisLed_G], HIGH);
    }
    // turn off all pins higher than the ledLevel:
    else {
      digitalWrite(ledPins_G[thisLed_G], LOW);
    }
  }

  // check if the pushbutton is pressed.
  // if it is, the buttonUPState is HIGH:
  if (buttonStateUP_D == HIGH) {
    if (VRState_D <6) {
 VRState_D++;
  Serial.println("VR D UP");
    }
    else VRState_D = 6;
  }

  // if it is, the buttonDOWNState is HIGH:
  if (buttonStateDOWN_D == HIGH) {
    if (VRState_D >0 ) {
  VRState_D--;
  Serial.println("VR D DOWN");
  }
    else { VRState_D = 0;}
    }

  Serial.print("Position VR D:");
  Serial.println(VRState_D);
  // map the result to a range from 0 to the number of LEDs:
  int ledLevel_D = map(VRState_D, 0, 6, 0, ledCount_D);

  // loop over the LED array:
  for (int thisLed_D = 0; thisLed_D < ledCount_D; thisLed_D++) {
    // if the array element's index is less than ledLevel,
    // turn the pin for this element on:
    if (thisLed_D < ledLevel_D) {
      digitalWrite(ledPins_D[thisLed_D], HIGH);
    }
    // turn off all pins higher than the ledLevel:
    else {
      digitalWrite(ledPins_D[thisLed_D], LOW);
    }
  }
delay(3000);
}

